MantisBT
Mantis Bug Tracker Workflow

View Issue Details Jump to Notes ] Related Changesets ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0026526Community[OCCT] OCCT:Modeling Datapublic2015-08-06 12:012016-04-20 15:48
ReporterVico Liang 
Assigned Tobugmaster 
PrioritynormalSeveritymajor 
StatusclosedResolutionfixed 
PlatformOSOS Version
Product Version[OCCT] 6.9.0 
Target Version[OCCT] 7.0.0Fixed in Version[OCCT] 7.0.0 
Summary0026526: BRepTools_WireExplorer can't explore all edges of a closed wire.
DescriptionTopoDS_Wire aWire = // Load from Wire_Explorer.brep
for (BRepTools_WireExplorer aWE(aWire); aWE.More(); aWE.Next())
{
 
}

The loop above can't iterate all edges of the wire, it will just iterate several edges of the wire.

Steps To ReproduceNot required
TagsNo tags attached.
Test case numberNot needed
Attached Files? file icon Wire_Explorer.brep (1,048 bytes) 2015-08-06 12:01
png file icon wire.PNG (49,786 bytes) 2015-09-22 13:55

- Relationships

-  Notes
(0046002)
ifv (developer)
2015-09-22 13:55

It is not a bug.
One of edge has bad orientation (see attached picture), so wire cannot be explored by BRepTools_WireExplorer.
(0046025)
msv (developer)
2015-09-23 11:28

I confirm. This tools works correctly only with correct input data. If a wire has incorrectly oriented edges the internal iteration stops.
If you need to iterate all the edges in incorrect wire you need to use TopoDS_Iterator, which returns not ordered edges, or ShapeExtend_WireData, which allows reordering.
(0046026)
msv (developer)
2015-09-23 11:30

Dear Vico, please confirm closing this bug.
(0046179)
Vico Liang (developer)
2015-09-27 17:07

Dear msv, yes, i agree that there is no incorrectly oriented edges. Do you think it's still possible to iterate the loop edges? anyway, it's a closed wire and all the edges are connected end-to-end.
(0046183)
msv (developer)
2015-09-28 09:28

Dear Vico, yes, it is possible to iterate on this loop. For that you can use the class ShapeExtend_WireData. It will return you edges ordered and tell about correct orientation.
(0046238)
Vico Liang (developer)
2015-09-29 04:51

Dear msv,

Thank you for your help. I suggest to enhance the document of BRepTools_WireExplorer to indicate such situation.
(0046309)
msv (developer)
2015-09-30 09:50

Dear ifv, please update the class description taking into account this situation.
(0046483)
ifv (developer)
2015-10-05 17:39

In my opinion, class description contains information that this algo cannot explore wrong wires:

 //!If a wire is not closed returns only a segment of edges which
 //! length depends on started in exploration edge. If wire has
 //! singularities (for example, loops) WireExplorer can return not all
 //! edges in a wire. it depends on type of singularity.
(0046484)
msv (developer)
2015-10-05 17:48

I propose to point the bad edge orientation as a particular case of singularity.
(0046485)
git (administrator)
2015-10-05 18:29

Branch CR26526 has been created by ifv.

SHA-1: d2129c5e626b09eb49af15554a8197aa35b1caac


Detailed log of new commits:

Author: ifv
Date: Mon Oct 5 18:29:25 2015 +0300

    0026526: BRepTools_WireExplorer can't explore all edges of a closed wire.
(0046486)
ifv (developer)
2015-10-05 18:31

Branch CR26526 is ready to review
(0046488)
msv (developer)
2015-10-05 18:49

Reviewed.
No need to test, as only comments were modified.
(0046514)
mkv (tester)
2015-10-06 15:09

Dear BugMaster,
Branch CR26526 from occt git-repository (and master from products git-repository) was compiled on Linux, MacOS and Windows platforms on Release mode.
SHA-1: d2129c5e626b09eb49af15554a8197aa35b1caac

Number of compiler warnings:

occt component :
Linux: 13 (13 on master)
Windows: 0 (0 on master)

products component :
Linux: 39 (39 on master)
Windows: 0 (0 on master)
(0046515)
mkv (tester)
2015-10-06 15:09

Dear BugMaster,
Branch CR26526 is TESTED.
(0047076)
git (administrator)
2015-10-16 16:57

Branch CR26526 has been deleted by kgv.

SHA-1: d2129c5e626b09eb49af15554a8197aa35b1caac

- Related Changesets
occt: master 94520b24
Timestamp: 2015-10-05 15:29:25
Author: ifv
Committer: bugmaster
Details ] Diff ]
0026526: BRepTools_WireExplorer can't explore all edges of a closed wire.
mod - src/BRepTools/BRepTools_WireExplorer.hxx Diff ] File ]

- Issue History
Date Modified Username Field Change
2015-08-06 12:01 Vico Liang New Issue
2015-08-06 12:01 Vico Liang Assigned To => msv
2015-08-06 12:01 Vico Liang File Added: Wire_Explorer.brep
2015-08-07 11:52 msv Assigned To msv => ifv
2015-09-22 13:55 ifv Note Added: 0046002
2015-09-22 13:55 ifv Assigned To ifv => msv
2015-09-22 13:55 ifv Status new => resolved
2015-09-22 13:55 ifv Steps to Reproduce Updated View Revisions
2015-09-22 13:55 ifv File Added: wire.PNG
2015-09-23 11:28 msv Note Added: 0046025
2015-09-23 11:28 msv Assigned To msv => bugmaster
2015-09-23 11:28 msv Status resolved => reviewed
2015-09-23 11:28 msv Resolution open => no change required
2015-09-23 11:30 msv Note Added: 0046026
2015-09-23 11:30 msv Assigned To bugmaster => Vico Liang
2015-09-23 11:30 msv Status reviewed => feedback
2015-09-27 17:07 Vico Liang Note Added: 0046179
2015-09-27 17:07 Vico Liang Assigned To Vico Liang => msv
2015-09-27 17:07 Vico Liang Status feedback => acknowledged
2015-09-28 09:28 msv Note Added: 0046183
2015-09-28 09:28 msv Assigned To msv => Vico Liang
2015-09-29 04:51 Vico Liang Note Added: 0046238
2015-09-29 04:52 Vico Liang Assigned To Vico Liang => msv
2015-09-30 09:50 msv Note Added: 0046309
2015-09-30 09:50 msv Assigned To msv => ifv
2015-09-30 09:50 msv Status acknowledged => assigned
2015-10-05 17:38 ifv Note Added: 0046482
2015-10-05 17:38 ifv Assigned To ifv => msv
2015-10-05 17:39 ifv Note Added: 0046483
2015-10-05 17:39 ifv Status assigned => feedback
2015-10-05 17:39 ifv Note Deleted: 0046482
2015-10-05 17:48 msv Note Added: 0046484
2015-10-05 17:48 msv Assigned To msv => ifv
2015-10-05 17:48 msv Status feedback => assigned
2015-10-05 18:29 git Note Added: 0046485
2015-10-05 18:31 ifv Note Added: 0046486
2015-10-05 18:31 ifv Assigned To ifv => msv
2015-10-05 18:31 ifv Status assigned => resolved
2015-10-05 18:49 msv Note Added: 0046488
2015-10-05 18:49 msv Assigned To msv => bugmaster
2015-10-05 18:49 msv Status resolved => reviewed
2015-10-05 18:50 msv Resolution no change required => documentation updated
2015-10-05 19:53 mkv Assigned To bugmaster => mkv
2015-10-06 15:09 mkv Note Added: 0046514
2015-10-06 15:09 mkv Note Added: 0046515
2015-10-06 15:09 mkv Assigned To mkv => bugmaster
2015-10-06 15:09 mkv Status reviewed => tested
2015-10-06 15:10 mkv Test case number => Not needed
2015-10-16 13:18 bugmaster Changeset attached => occt master 94520b24
2015-10-16 13:18 bugmaster Status tested => verified
2015-10-16 13:18 bugmaster Resolution documentation updated => fixed
2015-10-16 16:57 git Note Added: 0047076
2016-04-20 15:44 user533 Fixed in Version => 7.0.0
2016-04-20 15:48 user533 Status verified => closed


Copyright © 2000 - 2018 MantisBT Team
Powered by Mantis Bugtracker